Require Import Vtac Program List Arith Even Div2 Relations.
Require Import basis countable lang subs model basiclemmas weakiso funiso.
Set Implicit Arguments.

(*----------------------------------------------------------------------------*)
(** * properties of wprod *)
(*----------------------------------------------------------------------------*)

Lemma wexp_extend1: 
  forall 
    w1 w2 (WD: wdisj w1 w2) (STA: wstable w2)
    g (gOK: wglob (wlift (wprod w1 w2)) g) sr0 sr s10 s1 s20 s2 (E2: wextpub w2 s2 s20),
  wexp (wlift w1) (fun x => g (fst x,(snd x,s2))) (sr0,s10) (sr,s1) <3=
  wexp (wlift (wprod w1 w2)) g (sr0,(s10, s20)) (sr,(s1, s2)).
Proof.
  intros until s2; revert g gOK sr s1 s2; cofix CIH.
  intros until s2; intros ? ty e e' H h h' (hr & hr' & hab & hab' & HR & HAB & P & P'); intros. 
  destruct HAB as (ha & ha' & hb & hb' & HA & HB & PAB & PAB').
  destruct (hplus_assoc_r PAB P) as (hra & PRA & PRAB). 
  destruct (hplus_assoc_l PRAB HPLUS) as (hbf & PRABF & PBF).
  destruct (hplus_assoc_r PAB' P') as (hra' & PRA' & PRAB').
  destruct (hplus_assoc_l PRAB' HPLUS') as (hbf' & PRABF' & PBF').
  exploit H; try (by exists hr hr' ha ha'; eauto); eauto.
  clear H; intros H; destruct H; [by econstructor 1; eauto| |];
   (destruct HREL as (hr1 & hr2 & ha1 & ha2 & HREL); des;
    destruct (hplus_assoc_r PBF PLUS1) as (hrab1 & PRAB1' & PHH1);
    destruct (hplus_assoc_l HP PRAB1') as (hab1 & PRAB1 & PAB1); clear PRAB1';
    destruct (hplus_assoc_r PBF' PLUS2) as (hrab2 & PRAB2' & PHH2);
    destruct (hplus_assoc_l HP' PRAB2') as (hab2 & PRAB2 & PAB2); clear PRAB2';
    destruct (hplus_assoc_r (hplus_comm PAB1) PRAB1) as (hrb1 & PRB1 & _);
    destruct (hplus_assoc_r (hplus_comm PAB2) PRAB2) as (hrb2 & PRB2 & _);
    assert (gOK0:=gOK); rdes gOK0; revert WH; simpls; des; intro; 
    destruct s' as (sr' & s1');
    refine (mp (STA _ (wglob_prod2 WD gOK s1') _ _ _ _ _ _ WRE _ _ WH _ _ _ _) _);
     simpls; des; eauto 10 using wheap_mon;
    clear HB; intros (s2' & EXT2' & HB)).

  - assert (VREL': vclos (g (sr',(s1',s2'))) ty v1 v2) by eauto 10 using vclos_mon.
    econstructor 2; try apply VREL'; simpls; des; unnw; eauto using wextpub_trans.
    do 4 eexists; repeat split; eauto.
      by intros; specialize (HSAT _ _ _ R); des; eauto 15 using vclos_mon.
    by eauto 20 using wheap_mon.

  - assert (EREL': wstuck (g (sr', (s1', s2'))) (g (sr', (s1', s2'))) ty' e1 e2)
      by (unfold id in *; eapply wstuck_mon; eauto 10 using vclos_mon).
    econstructor 3; try apply EREL'; simpls; des; unnw; eauto using wextpub_trans.
    + do 4 eexists; repeat split; eauto.
        by intros; specialize (HSAT _ _ _ R); des; eauto 15 using vclos_mon.
      by eauto 20 using wheap_mon.
    + intros (sr'', (s1'',s2'')) [WEXT1 WEXT2] ? ? ? ? ? ? hcd hcd'
        (hc & hc' & hd & hd' & Hc & Hc' & Pc & Pc'); simpl; intros; des.
      eapply CIH; clear CIH; eauto using wextpub_trans; [|eby do 4 eexists].
      red; intros; eapply KREL; eauto.
        by eapply wglob_prod1; eauto.
      intros; eapply LT, GMON; try eassumption; 
       eauto 10 using wext_refl, wextpub_in_wext, wextpub_trans.
Qed.

Lemma wexp_extend2: 
  forall 
    w1 w2 (WD: wdisj w1 w2) (STA: wstable w1)
    g (gOK: wglob (wlift (wprod w1 w2)) g) sr0 sr s10 s1 s20 s2 (E1: wextpub w1 s1 s10),
  wexp (wlift w2) (fun x => g (fst x,(s1,snd x))) (sr0,s20) (sr,s2) <3=
  wexp (wlift (wprod w1 w2)) g (sr0,(s10,s20)) (sr,(s1,s2)). 
Proof.
  intros; eapply (wexp_fiso (swap_iso_ok w2 w1)); simpl; eauto.
  eapply wexp_extend1; eauto.
  by eapply fiso_glob in gOK; eauto using swap_iso_ok; simpls.
Qed.

Lemma winhabited_prod: forall 
    w1 w2 (DISJ: wdisj w1 w2) (I1: winhabited (wlift w1)) (I2: winhabited (wlift w2)),
  winhabited (wlift (wprod w1 w2)).
Proof. 
  red; intros.
  destruct (I1 (minvr (wlift w1)) (minvr_glob _)) as [[sr1 s1] (h11 & h12 & h13 & h14 & H1)].
  destruct (I2 (minvr (wlift w2)) (minvr_glob _)) as [[sr2 s2] (h21 & h22 & h23 & h24 & H2)].
  exists (sref0,(s1,s2)); repeat exists hemp; repeat split; eauto; try edone.
  des; repeat (match goal with [H:_|-_] => eapply hplus_hemp_inv in H end); des; subst.
  repeat (match goal with [H:_|-_] => apply sref0_hemp in H; simpl in H; subst end).
  repeat exists hemp; repeat split; eauto; (eapply wheap_mon; eauto).
  - by eapply (@minvr_init (wlift w1) (fun s => g (fst s,(snd s, s2)))); 
       eauto using wglob_prod1.
  - by eapply (@minvr_init (wlift w2) (fun s => g (fst s,(s1, snd s)))); 
       eauto using wglob_prod2.
Qed.

Lemma wconsistent_prod:
  forall w1 w2 (WD: wdisj w1 w2)
    (C1: wconsistent (wlift w1)) (STA1: wstable w1)
    (C2: wconsistent (wlift w2)) (STA2: wstable w2),
  wconsistent (wlift (wprod w1 w2)).
Proof. 
intros; intros g gOK [sref [s1 s2]] ty e1 e2 STUCK.
apply wstuck_lift in STUCK; eapply wstuck_prod in STUCK; des.
- exploit (C1 (fun s => g (fst s,(snd s,s2)))).
  + by eapply wglob_prod1.
  + eby instantiate (4:= (sref,s1)); eapply wstuck_lift.
  + intros; des; repeat eexists; try edone.
    by eapply wexp_extend1; simpls; eauto.
- exploit (C2 (fun s => g (fst s,(s1,snd s)))).
  + by eapply wglob_prod2.
  + eby instantiate (4:= (sref,s2)); eapply wstuck_lift.
  + intros; des; repeat eexists; try edone.
    by eapply wexp_extend2; simpls; eauto.
Qed.

Lemma wstable_prod :
  forall w1 w2 (WD: wdisj w1 w2)
    (STA1: wstable w1) (STA2: wstable w2),
  wstable (wprod w1 w2).
Proof.
red; intros; destruct s as (s1 &s2); simpl in HR; des.
destruct (hplus_assoc_r HP DIS) as (hsh1 & SHR1 & SHH1).
destruct (hplus_assoc_r HP' DIS0) as (hsh2 & SHR2 & SHH2).
apply hplus_comm in HP; eapply hplus_comm in HP'.
destruct (hplus_assoc_r HP DIS) as (hsh1' & SHR1' & SHH1').
destruct (hplus_assoc_r HP' DIS0) as (hsh2' & SHR2' & SHH2').
refine (mp (STA1 (fun s : wst (wlift w1) => g (fst s,(snd s,s2))) 
            _ _ _ _ _ _ _ EXT _ _ _ _ _ _ _) _);
 eauto using wglob_prod1.
intros; des.
refine (mp (STA2 (fun s : wst (wlift w2) => g (fst s,(s1,snd s)))
            _ _ _ _ _ _ _ EXT _ _ _ _ _ _ _) _);
 eauto using wglob_prod2.
intros; rdes gOK; simpls; des; eexists (s',s'0).
by eauto 30 using wheap_mon, wextpub_trans.
Qed.

Hint Resolve winhabited_prod wconsistent_prod wstable_prod.

(*----------------------------------------------------------------------------*)
(** * Compatibility *)
(*----------------------------------------------------------------------------*)

Tactic Notation "replace_all" constr(e) :=
  let X := fresh in assert (X: e) by clarify; setoid_rewrite X; clear X.

(** The next set of lemmas are helper lemmas for proving the compatibility
    lemmas. *)


Lemma meta0r : 
  forall D G ty e e' (OK: wequiv D G (wlift wid) ty e e'),
    wreq D G ty e e'.
Proof.
  by red; intros; eexists wid; split; [|split;[|split]]; eauto; simpls.
Qed.

Lemma meta1r : 
  forall
    D1 G1 ty1 e1 e1' (E1: wreq D1 G1 ty1 e1 e1')
    D G ty e e' (OK: forall w (STA: wstable w)
                       (E1: wequiv D1 G1 (wlift w) ty1 e1 e1'),
                     wequiv D G (wlift w) ty e e'),
    wreq D G ty e e'.
Proof.
  by red; intros; specialize (E1 _ INF); des; unfold weq; rdes WEQ; eauto 10.
Qed.

Lemma meta1 : 
  forall
    D1 G1 ty1 e1 e1' (E1: wreq D1 G1 ty1 e1 e1')
    G D ty e e' (OK: forall w 
                       (E1: wequiv D1 G1 w ty1 e1 e1'),
                     wequiv D G w ty e e'),
  wreq D G ty e e'.
Proof. eauto using meta1r. Qed.

Lemma meta2r : 
  forall
    D1 G1 ty1 e1 e1' (E1: wreq D1 G1 ty1 e1 e1')
    D2 G2 ty2 e2 e2' (E2: wreq D2 G2 ty2 e2 e2')
    G D ty e e' (OK: forall w (STA: wstable w)
                       (E1: wequiv D1 G1 (wlift w) ty1 e1 e1')
                       (E2: wequiv D2 G2 (wlift w) ty2 e2 e2'),
                     wequiv D G (wlift w) ty e e'),
    wreq D G ty e e'.
Proof.
  red; intros; apply countably_infinite_split in INF; des.
  destruct (E1 _ Nci1) as [w1 PW]; destruct (E2 _ Nci2) as [w2 PW']; des; clarify.
  assert (DIS: wdisj w1 w2) by (eby eapply ndisj_mon).
  rdes WEQ0; rdes WEQ.
  exists (wprod w1 w2); simpl; split; [|split;[|split;[|split]]]; unnw; eauto.
    by red; destruct 1; constructor (by auto).
  destruct EQ, EQ0; eapply OK; eauto;
   constructor; eauto; intros; destruct s as [sref [s1 s2]].
  - by eapply wexp_extend1; eauto using wglob_prod1.
  - by eapply wexp_extend2; eauto using wglob_prod2.
Qed.

Lemma meta2 : 
  forall
    D1 G1 ty1 e1 e1' (E1: wreq D1 G1 ty1 e1 e1')
    D2 G2 ty2 e2 e2' (E2: wreq D2 G2 ty2 e2 e2') 
    G D ty e e' (OK: forall w
                       (E1: wequiv D1 G1 w ty1 e1 e1')
                       (E2: wequiv D2 G2 w ty2 e2 e2'),
                     wequiv D G w ty e e'),
    wreq D G ty e e'.
Proof.
  intros; eauto using meta2r. 
Qed.

Lemma meta3r : 
  forall
    D1 G1 ty1 e1 e1' (E1: wreq D1 G1 ty1 e1 e1')
    D2 G2 ty2 e2 e2' (E2: wreq D2 G2 ty2 e2 e2')
    D3 G3 ty3 e3 e3' (E3: wreq D3 G3 ty3 e3 e3') 
    G D ty e e' (OK: forall w (STA: wstable w)
                       (E1: wequiv D1 G1 (wlift w) ty1 e1 e1')
                       (E2: wequiv D2 G2 (wlift w) ty2 e2 e2')
                       (E3: wequiv D3 G3 (wlift w) ty3 e3 e3'),
                     wequiv D G (wlift w) ty e e'),
    wreq D G ty e e'.
Proof.
  red; intros; apply countably_infinite_split in INF; des; subst.
  apply countably_infinite_split in Nci2; des; subst.
  destruct (E1 _ Nci1) as [w1 PWA];
  destruct (E2 _ Nci0) as [w2 PWB]; 
  destruct (E3 _ Nci2) as [w3 PWC]; des; clarify.
  assert (wdisj w2 w3) by (eapply (ndisj_mon Ndisj0); eauto).
  assert (wdisj w1 (wprod w2 w3)). 
    by eapply (ndisj_mon Ndisj); simpls; red; destruct 1; constructor (by auto).
  rdes WEQ; rdes WEQ0; rdes WEQ1.
  exists (wprod w1 (wprod w2 w3)); split; [|split;[|split;[|split]]]; unnw; eauto.
    by red; destruct 1 as [|[]]; constructor (solve[ auto | constructor (by auto)]).
  destruct EQ, EQ0, EQ1; eapply OK; eauto;
   constructor; eauto; intros; destruct s as [sref [s1 [s2 s3]]].
  - by eapply wexp_extend1; eauto using wglob_prod1.
  - eapply wexp_extend2; eauto.
    eapply wexp_extend1; eauto using wglob_prod1, wglob_prod2.
    by eapply WEXP0; eauto; eapply wglob_prod2, wglob_prod1 in gOK; eauto.
  - eapply wexp_extend2; eauto.
    eapply wexp_extend2; eauto using wglob_prod2.
    by eapply WEXP; eauto; eapply wglob_prod2, wglob_prod2 in gOK; eauto.
Qed.

Lemma meta3 : 
  forall
    D1 G1 ty1 e1 e1' (E1: wreq D1 G1 ty1 e1 e1')
    D2 G2 ty2 e2 e2' (E2: wreq D2 G2 ty2 e2 e2')
    D3 G3 ty3 e3 e3' (E3: wreq D3 G3 ty3 e3 e3') 
    G D ty e e' (OK: forall w
                       (E1: wequiv D1 G1 w ty1 e1 e1')
                       (E2: wequiv D2 G2 w ty2 e2 e2')
                       (E3: wequiv D3 G3 w ty3 e3 e3'),
                     wequiv D G w ty e e'),
    wreq D G ty e e'.
Proof. intros; eapply (meta3r E1 E2 E3); eauto. Qed.

(*----------------------------------------------------------------------------*)
(** ** Variables and conditionals *)
(*----------------------------------------------------------------------------*)

Lemma compat_var : 
  forall x 
    D G (envOK: forall x ty0 (IN: In (x,ty0) G), lc_typ 0 ty0)
    ty (tyOK: lc_typ 0 ty) (IN: list_assoc eq_termvar x G = Some ty), 
  wreq D G ty (Evar x) (Evar x).
Proof.
  eexists wid; split; [done|]; repeat split; eauto.
  - by simpl; rewrite list_mem_map_fst, IN.
  - by simpl; rewrite list_mem_map_fst, IN.
  - red; intros; simpl; revert G ggOK IN GEQ envOK.
    induction gg as [|[[x' ty'][v v']] gg IH]; simpl in *; intros; clarify.
    simpl in *; destruct (eq_termvar x' x); [|eapply IH; eauto]; clarify.
    eapply wexp_val; auto; intros; eapply ggOK; eauto; left; repeat f_equal.
Qed.

Lemma compat_if : 
  forall D G
    e1 e1' (E1: wreq D G Tbool e1 e1')
    ty e2 e2' (E2: wreq D G ty e2 e2')
    e3 e3' (E3: wreq D G ty e3 e3'),
  wreq D G ty (Eif e1 e2 e3) (Eif e1' e2' e3').
Proof.
  intros; eapply (meta3 E1 E2 E3); clear E1 E2 E3. 
  intros; destruct E1, E2, E3; constructor; eauto.
  - by simpl; rewrite !list_minus_app, FV1, FV0, FV4.
  - by simpl; rewrite !list_minus_app, FV2, FV3, FV5.
  - red; intros; simpls.
    replace_all (forall a b c, Eif a b c = app_cont (Kif Khole b c) a).
    eapply wexp_app_cont, WEXP; eauto.
    do 2 red; intros; eapply wexp_mon; eauto; destruct VREL; inv REL.
    + do 2 red; intros; eapply wexp_core_reduces; try eapply reduces_step, reduces_nil;
       try eapply Rtrue; try eapply WEXP0; eauto. 
      intros; eapply vclos_mon; try eapply ggOK, IN; intros. 
      by eapply (proj1 (proj2 g'OK)), EXT; eauto.
    + do 2 red; intros; eapply wexp_core_reduces; try eapply reduces_step, reduces_nil;
        try eapply Rfalse; try eapply WEXP1; eauto. 
      intros; eapply vclos_mon; try eapply ggOK, IN; intros.
      by eapply (proj1 (proj2 g'OK)), EXT; eauto.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Products *)
(*----------------------------------------------------------------------------*)

Lemma compat_pair : 
  forall D G
    ty1 e1 e1' (E1: wreq D G ty1 e1 e1')
    ty2 e2 e2' (E2: wreq D G ty2 e2 e2'),
  wreq D G (Tprod ty1 ty2) (Epair e1 e2) (Epair e1' e2').
Proof.
  intros; eapply (meta2 E1 E2); clear E1 E2.
  intros; destruct E1, E2; constructor; simpl; eauto.
  - by simpl; rewrite !list_minus_app, FV1, FV0.
  - by simpl; rewrite !list_minus_app, FV2, FV3.
  - red; intros; simpls.
    replace_all (forall a b, Epair a b = app_cont (KpairL Khole b) a).
    eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
    replace_all (forall (a:val) b, Epair a b = app_cont (KpairR a Khole) b).
    eapply wexp_app_cont; eauto.
    + intros; do 2 red; intros; simpl; fold wexp.
      eapply wexp_val with (v := Vpair _ _) (v' := Vpair _ _); eauto using wextpub_trans.
      intros _; rdes g'OK; eauto 10 using vclos_mon.
    + do 2 red in WEXP0 |- *; assert (X:=g'OK); rdes X.
      by intros; eapply wexp_core_mon; try eapply WEXP0; eauto using vclos_mon.
Qed. 

Lemma compat_fst : 
  forall D G ty1 ty2
      e e' (E: wreq D G (Tprod ty1 ty2) e e'),
    wreq D G ty1 (Efst e) (Efst e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; des; eauto.
  red; intros; simpls.  
  replace_all (forall a, Efst a = app_cont (Kfst Khole) a).
  eapply wexp_app_cont, WEXP; try red; simpl; eauto. 
  repeat intro; simpl; destruct VREL; inv REL; clarify.
  by econstructor 2; try eapply V1; eauto; vauto. 
Qed.

Lemma compat_snd : 
  forall D G ty1 ty2
    e e' (E: wreq D G (Tprod ty1 ty2) e e'),
  wreq D G ty2 (Esnd e) (Esnd e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; des; eauto.
  red; intros; simpls.  
  replace_all (forall a, Esnd a = app_cont (Ksnd Khole) a).
  eapply wexp_app_cont, WEXP; try red; simpl; eauto.
  repeat intro; simpl; destruct VREL; inv REL; clarify.
  by econstructor 2; try eapply V2; eauto; vauto. 
Qed.

(*----------------------------------------------------------------------------*)
(** ** Functions *)
(*----------------------------------------------------------------------------*)

Program Definition wfix D G ty1 ty2 (f x : termvar) e e'
   (FV1 : list_minus eq_termvar (fv_exp e) (x :: f :: map fst G) = nil)
   (FV2 : list_minus eq_termvar (fv_exp e') (x :: f :: map fst G) = nil)
:= wsingle 
   (fun r ty v v' =>
      exists gg : list (_ * (val * val)), exists d,
        map fst d = D 
        /\ (map fst gg = G)
        /\ (forall x : typename * typ, In x d -> lc_typ 0 (snd x))
        /\ (forall (x0 : termvar) (ty : typ) v1 v2,
              In (x0, ty, (v1, v2)) gg -> vclos (r) (tsubst_typ d ty) v1 v2)
        /\ lc_typ 0 ty
        /\ ty = FTarrow (tsubst_typ d ty1) (tsubst_typ d ty2)
        /\ v  = subst_val (map_pair fst (fun x => exp_of_val (fst x)) gg) (Vfix f x e)
        /\ v' = subst_val (map_pair fst (fun x => exp_of_val (snd x)) gg) (Vfix f x e'))
   (fun _ h h' => h = hemp /\ h' = hemp)
   _ _ _ _ _.
Next Obligation. des; eauto 15 using vclos_mon, vclos_closed. Qed.
Next Obligation. 
des; subst; split; eauto; split; simpls;
 rewrite fv_subst_exp, list_minus_comm, list_map_fst_minus2.
- by rewrite map_fst_map_pair, list_minus_red, <- (list_minus_app_r).
- apply subst_closed_minus2, subst_closed_gg.
  by intros ((?&?)&?&?); intros; simpl; assert (X:= vclos_closed); hdes; eauto.
- by rewrite map_fst_map_pair, list_minus_red, <- (list_minus_app_r).
- apply subst_closed_minus2, subst_closed_gg.
  by intros ((?&?)&?&?); intros; simpl; assert (X:= vclos_closed); hdes; eauto.
Qed.
Next Obligation. simpls; des; subst; split; eexists; econstructor. Qed.

Lemma wexp_hack:
  forall w r s0 s ty e e' e1 e2,
    e = e1 -> e' = e2 ->
    wexp w r s0 s ty e1 e2 -> 
  wexp w r s0 s ty e e'.
Proof. intros; clarify. Qed.

Lemma wfix_wdisj: forall {w D G ty1 ty2 f x e e' FV1 FV2},
  wdisj w (wfix D G ty1 ty2 f x e e' FV1 FV2).
Proof. by repeat intro; eauto. Qed.
Hint Resolve @wfix_wdisj.

Lemma wfix_stable: forall {D G ty1 ty2 f x e e' FV1 FV2}, 
  wstable (wfix D G ty1 ty2 f x e e' FV1 FV2).
Proof. by repeat intro; simpls; des; subst; discriminate. Qed.
Hint Resolve @wfix_stable.

Lemma wconsistent_fix:
  forall D G ty1 ty2 f x e e' FV1 FV2 w 
    (C: wconsistent (wlift w))
    (E : wequiv D ((x, ty1) :: (f, Tarrow ty1 ty2) :: G) (wlift w) ty2 e e'),
  wconsistent (wlift (wprod w (wfix D G ty1 ty2 f x e e' FV1 FV2))).
Proof.
  red; intros; destruct s as (sr&s1&()).
  eapply wstuck_lift, wstuck_prod in APP; des.
    exploit (C _ (wglob_prod1 wfix_wdisj gOK ())).
    - by instantiate (4:=(sr,s1)); eapply wstuck_lift; eauto.
    - intros; des; do 2 eexists; repeat split; eauto. 
      by eapply wexp_extend1; eauto.
  dependent destruction APP; simpls; des; subst; [|by discriminate].
  do 2 eexists; do 2 (split; [by intros; constructor|]).
  assert (gOK0:=gOK); red in gOK0; des; destruct E; inv FREL4.
  eapply wexp_extend1; simpls; eauto.
  specialize (WEXP (sr,s1) _ (wglob_prod1 wfix_wdisj gOK ()) _ eq_refl FREL1).
  rewrite !subst_exp_app_disj; simpl.
  - eapply wexp_hack, (WEXP ((_, (v1, v2)) :: (_, (
      Vfix f x (subst_exp (list_minus2 eq_termvar (map_pair fst 
                 (fun x => exp_of_val (fst x)) gg) [x;f]) e) , 
      Vfix f x (subst_exp (list_minus2 eq_termvar (map_pair fst
                 (fun x => exp_of_val (snd x)) gg) [x;f]) e'))) 
      :: gg) (refl_equal _)); try apply subst_exp_eq.
    + simpls; f_equal; destruct (eq_termvar); simpls; [|f_equal]; 
      rewrite <- list_minus2_remdup2, <- !list_minus2_app_r; simpl;
      apply list_minus2_eq; simpl; tauto.
    + simpls; f_equal; destruct (eq_termvar); simpls; [|f_equal]; 
      rewrite <- list_minus2_remdup2, <- !list_minus2_app_r; simpl;
      apply list_minus2_eq; simpl; tauto.
    + simpl; intros; des; clarify; simpl; eauto.
      by do 2 econstructor; eauto; apply gOK; right; right; simpl; eauto 20.
  - eapply subst_closed_minus2, subst_closed_gg.
    by intros ((?&?)&?&?) IN; eapply vclos_closed; eauto.
  - rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
    by repeat destruct eq_termvar; clarify.
  - eapply subst_closed_minus2, subst_closed_gg.
    by intros ((?&?)&?&?) ?; refine (mp (@vclos_closed _ _ v v0 _) _);
       [|intros X; apply X]; eauto.
  - rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
    by repeat destruct eq_termvar; clarify.
Qed.

Lemma compat_fix :
  forall D G ty1 ty2
    (f x: termvar) e e' (E: wreq D ((x,ty1)::(f,Tarrow ty1 ty2)::G) ty2 e e'),
  wreq D G (Tarrow ty1 ty2) (Efix f x e) (Efix f x e').
Proof.
  red; intros; specialize (E _ INF).
  des; rdes WEQ; destruct EQ; simpls; unnw. 
  eexists (wprod w (wfix D G ty1 ty2 f x e e' FV1 FV2)).
  split; [by destruct 1; apply NAM|split;[|split;[|split]]]; unnw; eauto.
  - eby apply winhabited_prod; try edone; exists (sref0,());
        repeat exists hemp; repeat split; vauto.
  - by eapply wconsistent_fix.
  - constructor; eauto 15.
    + by simpl; rewrite <- !list_minus_app_r; eauto.
    + by simpl; rewrite <- !list_minus_app_r; eauto.
    + red; intros; simpl.
      replace_all (forall a, Efix f x a = Vfix f x a).
      eapply wexp_val; auto; intros; do 2 econstructor; eauto.
      apply gOK; right; right; do 2 eexists; repeat (split; eauto).
      * by eapply lc_tsubst; eauto; eapply dOK.
      * by eapply lc_tsubst; eauto; eapply dOK.
Qed.

Lemma compat_app : 
  forall D G ty2 ty1
    e1 e1' (E1: wreq D G (Tarrow ty2 ty1) e1 e1')
    e2 e2' (E2: wreq D G ty2 e2 e2'),
  wreq D G ty1 (Eapp e1 e2) (Eapp e1' e2').
Proof.
  intros; eapply (meta2 E1 E2); clear E1 E2.
  intros; destruct E1, E2; constructor; simpls; des; eauto.
  - by simpl; rewrite !list_minus_app, FV1, FV0.
  - by simpl; rewrite !list_minus_app, FV2, FV3.
  - red; intros; simpl. 
    replace_all (forall a b, Eapp a b = app_cont (KappL Khole b) a).
    eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
    replace_all (forall (a:val) b, Eapp a b = app_cont (KappR a Khole) b).
    destruct VREL; inv REL ; clarify.
    eapply wexp_app_cont, WEXP0; simpls; des; eauto.
    + econstructor 3 with (K1 := Khole) (K2 := Khole); simpl; eauto using reduces_nil.
        by econstructor; eauto; eapply (proj1(proj2 g'OK0)), EXT0; eauto.
      by econstructor 2; simpl; eauto using reduces_nil, wextpub_trans.
    + intros; eapply vclos_mon;  eauto; intros; eapply (proj1 (proj2 g'OK)), EXT; eauto.
Qed. 


(*----------------------------------------------------------------------------*)
(** ** Sums *)
(*----------------------------------------------------------------------------*)

Lemma compat_inl : 
  forall D G
    ty1 e e' (E: wreq D G ty1 e e') ty2 (ty2OK: lc_typ 0 ty2),
  wreq D G (Tsum ty1 ty2) (Einl e) (Einl e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; des; eauto.
  red; intros; simpl. 
  replace_all (forall a, Einl a = app_cont (Kinl Khole) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  replace_all (forall v : val, Einl v = Vinl v).
  apply wexp_val; intros; eauto using lc_tsubst.
Qed.

Lemma compat_inr : 
  forall D G
    ty2 e e' (E: wreq D G ty2 e e') ty1 (ty1OK: lc_typ 0 ty1),
  wreq D G (Tsum ty1 ty2) (Einr e) (Einr e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; des; eauto.
  red; intros; simpl. 
  replace_all (forall a, Einr a = app_cont (Kinr Khole) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  replace_all (forall v : val, Einr v = Vinr v).
  apply wexp_val; intros; eauto using lc_tsubst.
Qed.

Lemma compat_case : 
  forall D G ty1 ty2 
    e e' (E: wreq D G (Tsum ty1 ty2) e e') ty (x: termvar)
    e1 e1' (E1: wreq D ((x,ty1)::G) ty e1 e1')
    e2 e2' (E2: wreq D ((x,ty2)::G) ty e2 e2'),
  wreq D G ty (Ecase x e e1 e2) (Ecase x e' e1' e2').
Proof.
  intros; eapply (meta3 E E1 E2); clear E E1 E2.
  intros; destruct E1, E2, E3; constructor; simpls; des; eauto.
  - rewrite !list_minus_app, <-!list_minus_app_r. 
    by simpl; rewrite FV1, FV0, FV4.
  - rewrite !list_minus_app, <-!list_minus_app_r. 
    by simpl; rewrite FV2, FV3, FV5.

  intros; simpls.
  replace_all (forall a b c, Ecase x a b c = app_cont (Kcase x Khole b c) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  eapply wexp_mon; eauto; simpl in VREL; des; clarify; simpl; red; intros.
  destruct VREL; inv REL; clarify.

  Case "Left".
  specialize (WEXP0 s' _ g'OK _ eq_refl dOK ((x, ty1, (v1, v1')) :: gg) eq_refl).
  red in gOK|-*; des; intros; eapply wexp_core_reduces, WEXP0; eauto; 
   try (eapply reduces_step; [eapply Rinl|]).
  - rewrite subst_exp_app_disj; simpl; try rewrite subst_exp_cons_minus2; vauto.
    + apply subst_closed_minus2, (subst_closed_gg fst).
      by intros ((?&?)&?&?) ?; refine (mp (@vclos_closed _ _ v v0 _) _);
         [|intros X; apply X]; eauto.
    + rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
      by repeat destruct eq_termvar; clarify.
  - rewrite subst_exp_app_disj; simpl; try rewrite subst_exp_cons_minus2; vauto.
    + apply subst_closed_minus2, (subst_closed_gg snd).
      by intros ((?&?)&?&?) IN; eapply vclos_closed; eauto.
    + rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
      by repeat destruct eq_termvar; clarify.
  - by red in g'OK; simpl; intros; des; clarify; eauto 10 using vclos_mon.

  Case "Right".
  specialize (WEXP1 s' _ g'OK _ eq_refl dOK ((x, ty2, (v2, v2')) :: gg) eq_refl).
  red in gOK|-*; des; intros; eapply wexp_core_reduces, WEXP1; eauto;
   try (eapply reduces_step; [eapply Rinr|]).
  - rewrite subst_exp_app_disj; simpl; try rewrite subst_exp_cons_minus2; vauto.
    + apply subst_closed_minus2, (subst_closed_gg fst).
      by intros ((?&?)&?&?) ?; refine (mp (@vclos_closed _ _ v v0 _) _);
         [|intros X; apply X]; eauto.
    + rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
      by repeat destruct eq_termvar; clarify.
  - rewrite subst_exp_app_disj; simpl; try rewrite subst_exp_cons_minus2; vauto.
    + apply subst_closed_minus2, (subst_closed_gg snd).
      by intros ((?&?)&?&?) IN; eapply vclos_closed; eauto.
    + rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
      by repeat destruct eq_termvar; clarify.
  - by red in g'OK; simpl; intros; des; clarify; eauto 10 using vclos_mon.
Qed.


(*----------------------------------------------------------------------------*)
(** ** References *)
(*----------------------------------------------------------------------------*)

Program Definition wrefst_ext (s : { s | wrefst s }) newty loc loc' 
  (CL: lc_typ 0 newty)
  (PF : forall ty loc', s ty loc loc' -> False)
  (PF' : forall ty loc, s ty loc loc' -> False) : { s | wrefst s }  :=
  exist _ (fun ty loc1 loc2 => ty = newty /\ loc1 = loc /\ loc2 = loc' \/ s ty loc1 loc2) _.
Next Obligation.
  destruct s; red; simpls; rdes w; hdesH w0.
  split; [by intros; des; subst; eauto|].
  split; [by split; intros; des; do 2 subst; first [by exfalso; eauto | eauto]|].
  exists (newty :: tydom) (loc::loc'::ldom); intros.
  des; hdes; subst; simpls; eauto 15.
Qed.

Lemma compat_ref : 
  forall D G
    ty e e' (E: wreq D G ty e e'),
  wreq D G (Tref ty) (Enew e) (Enew e').
Proof.
  intros; eapply (meta1r E); clear E. 
  intros; destruct E1; constructor; simpls; des; eauto.
  intros; simpls. 
  replace_all (forall a, Enew a = app_cont (Knew Khole) a).
  eapply wexp_app_cont, WEXP; eauto.
  intros; destruct s as [sref sw]; destruct s' as [sref' sw'].
  do 2 red; intros; eapply (wexp_fiso (id_intro_ok w)); eauto.
  simpls; des; eapply wexp_extend2; simpls; eauto.
    by eapply fiso_glob in g'OK; eauto using id_intro_ok; simpls.
  eapply (wexp_fiso id_elim_ok); simpl; eauto using wglob_wid.    

  repeat intro; red in gOK, g'OK; des. 
  assert (Ahh := allocator_unalloc hh).
  assert (Ahh':= allocator_unalloc hh').
  assert (CL: lc_typ 0 (tsubst_typ d ty)) by eauto using lc_tsubst.
  assert (PF: forall ty loc', ~ `sref' ty (allocator hh) loc').
    by eapply (hplus_none HPLUS) in Ahh; intros ? ? Y; 
       destruct (proj1 HREL _ _ _ Y); des; clarify.
  assert (PF': forall ty loc, ~ `sref' ty loc (allocator hh')).
    by eapply (hplus_none HPLUS') in Ahh'; intros ? ? Y; 
       destruct (proj1 HREL _ _ _ Y); des; clarify.
  eapply wexp_Terminate with 
        (s' := wrefst_ext sref' _ _ _ CL PF PF')
        (h1 := hext h (allocator hh) v)
        (h2 := hext h' (allocator hh') v')
        (v1 := Vloc _) (v2 := Vloc _)
        (hh := hh) (hh' := hh')
        (hh1 := hext hh (allocator hh) v)
        (hh2 := hext hh' (allocator hh') v');
      simpl; eauto using reduces_step, reduces_nil, Rnew.
  - do 2 econstructor; eauto; eapply GSUP; left.
    do 3 eexists; repeat (split; simpl; eauto).
  - repeat red in HREL; des; split; unnw.
    2: by split; intros; destruct eq_nat_dec; subst; 
          [|edestruct HDOM1| |edestruct HDOM2]; des; eauto 10.
    intros; destruct R as [|R]; des; clarify.
    + do 2 destruct (Peano_dec.eq_nat_dec); clarify; eauto; repeat eexists; try done.
      eapply vclos_mon; eauto; intros.
      by eapply GMON; simpls; eauto 10.
    + specialize (HSAT _ _ _ R); des.
      eapply (hplus_none HPLUS) in Ahh; des.
      eapply (hplus_none HPLUS') in Ahh'; des.
      do 2 destruct (Peano_dec.eq_nat_dec); clarify; eauto; repeat eexists; try eassumption.
      eapply vclos_mon; eauto; intros.
      by eapply GMON; simpl; eauto 10.
  - intro x; generalize (HPLUS x); simpl; destruct eq_nat_dec; clarify.
    by rewrite allocator_unalloc; intros; des; eauto.
  - intro x; generalize (HPLUS' x); simpl; destruct eq_nat_dec; clarify.
    by rewrite allocator_unalloc; intros; des; eauto.
Qed.

Lemma compat_read : 
  forall D G ty 
    e e' (E: wreq D G (Tref ty) e e'),
  wreq D G ty (Eread e) (Eread e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; eauto.
  intros; simpl. 
  replace_all (forall a, Eread a = app_cont (Kread Khole) a).
  eapply wexp_app_cont, WEXP; eauto.
  do 3 red; intros; destruct VREL; inv REL; clarify; red in gOK, g'OK; des.
  eapply GSUP in VR; simpl in VR; des; subst; [|by apply wlocal_nonref in VR]; clarify.
  destruct HREL as (href & href' & hw & hw' & REF & ? & P & P'); unnw.
  eapply REF in TLL; des.
  eapply (hplus_some1 P), (hplus_some1 HPLUS) in HL.
  eapply (hplus_some1 P'), (hplus_some1 HPLUS') in HL'.
  eapply wexp_Terminate; try (by simpl; vauto); auto.
  by exists href; exists href'; exists hw; exists hw'.
Qed.

Lemma compat_write : 
  forall D G ty 
    e1 e1' (E1: wreq D G (Tref ty) e1 e1')
    e2 e2' (E2: wreq D G ty e2 e2'),
    wreq D G Tunit (Ewrite e1 e2) (Ewrite e1' e2').
Proof.
  intros; eapply (meta2r E1 E2); clear E1 E2.
  intros; destruct E1, E2; constructor; simpls; des; eauto.
  - by simpl; rewrite !list_minus_app, FV1, FV0.
  - by simpl; rewrite !list_minus_app, FV2, FV3.

  intros; simpls. 
  replace_all (forall a b, Ewrite a b = app_cont (KwriteL Khole b) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  replace_all (forall (a:val) b, Ewrite a b = app_cont (KwriteR a Khole) b).
  eapply wexp_app_cont, WEXP0; eauto.
  2: by intros; eapply vclos_mon; eauto; intros; eapply (proj1 (proj2 g'OK)), EXT; eauto.
  intros; destruct s as [sref sw]; destruct s'0 as [sref' sw']; destruct s' as [sref'' sw''].

  do 2 red; intros; eapply (wexp_fiso (id_intro_ok w)); eauto.
  simpls; des; eapply wexp_extend2; simpls; eauto using wextpub_trans.
    by eapply fiso_glob in g'OK0; eauto using id_intro_ok; simpls.    
  eapply (wexp_fiso id_elim_ok); simpl; eauto using wglob_wid.

  red; intros; simpl; inv VREL; clarify.
  destruct VREL; inv REL; clarify; eapply LT0 in VR.
  eapply (proj2 (proj2 g'OK0)) in VR; simpl in VR.
  destruct VR as [(loc & loc' & ty' & ?&?&?& VR)|VR]; [|by apply wlocal_nonref in VR];
   unnw; clarify.
  red; intros; eapply WRE in VR; assert (X:= proj1 HREL _ _ _ VR); des.
  eapply wexp_Terminate with 
        (h1 := hext h loc v0) (h2 := hext h' loc' v'0) 
        (hh1 := hext hh loc v0) (hh2 := hext hh' loc' v'0)
        (v1 := Vunit) (v2 := Vunit).
  - by simpls; des; eauto using wextpub_trans; red; eauto.
  - by simpls; des; eauto using wextpub_trans; red; eauto.
  - by constructor; simpls.
  - split; unnw; simpls; des. 
    2: by split; intros; destruct eq_nat_dec; subst; 
          [|edestruct HDOM1| |edestruct HDOM2]; des; eauto 10.
    intros; specialize (HSAT _ _ _ R); des; clarify.
    destruct (proj1(proj2(proj2_sig sref')) _ _ _ VR _ _ _ R) as [A A'].
    by unfold hext; do 2 destruct (Peano_dec.eq_nat_dec); clarify; eauto;
       do 2 eexists; (split; [|split]); unnw; eauto;
       try (by destruct A; clarify); try (by destruct A'; clarify).
  - by intro x; clear -HL HPLUS; specialize (HPLUS x); simpl;
       destruct eq_nat_dec; des; intuition congruence.
  - by intro x; clear -HL' HPLUS'; specialize (HPLUS' x); simpl;
       destruct eq_nat_dec; des; intuition congruence.
  - simpl; pattern hh at 1; replace hh with (hext hh loc v). 
      by eauto using reduces_step, reduces_nil, Rwrite, wextpub_trans.
    by eapply heap_eq; intros x; specialize (HPLUS x); simpl;
       destruct eq_nat_dec; des; intuition congruence.
  - simpl; pattern hh' at 1; replace hh' with (hext hh' loc' v'). 
      by eauto using reduces_step, reduces_nil, Rwrite, wextpub_trans.
    by eapply heap_eq; intros x; specialize (HPLUS' x); simpl;
       destruct eq_nat_dec; des; intuition congruence.
Qed.

Lemma compat_refeq : 
  forall D G ty 
    e1 e1' (E1: wreq D G (Tref ty) e1 e1')
    e2 e2' (E2: wreq D G (Tref ty) e2 e2'),
    wreq D G Tbool (Erefeq e1 e2) (Erefeq e1' e2').
Proof.
  intros; eapply (meta2r E1 E2); clear E1 E2.
  intros; destruct E1, E2; constructor; simpls; des; eauto.
  - by simpl; rewrite !list_minus_app, FV1, FV0.
  - by simpl; rewrite !list_minus_app, FV2, FV3.

  intros; simpls. 
  replace_all (forall a b, Erefeq a b = app_cont (KrefeqL Khole b) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  replace_all (forall (a:val) b, Erefeq a b = app_cont (KrefeqR a Khole) b).
  eapply (wexp_app_cont), WEXP0; eauto.
  2: by intros; eapply vclos_mon; eauto; intros; eapply (proj1 (proj2 g'OK)), EXT; eauto.
  intros; destruct s as [sref sw]; destruct s'0 as [sref' sw']; destruct s' as [sref'' sw''].

  do 2 red; intros; eapply (wexp_fiso (id_intro_ok w)); eauto.
  simpls; des; eapply wexp_extend2; simpls; eauto using wextpub_trans.
    by eapply fiso_glob in g'OK0; eauto using id_intro_ok; simpls.
  eapply (wexp_fiso id_elim_ok); simpl; eauto using wglob_wid.

  destruct VREL; inv REL; destruct VREL0; inv REL0; eapply LT0 in VR.
  eapply (proj2 (proj2 g'OK0)) in VR; eapply (proj2 (proj2 g'OK0)) in VR0; simpl in VR, VR0.
  destruct VR as [(loc1 & loc1' & ? & ?&?&?& VREL1)|VREL1]; [|by apply wlocal_nonref in VREL1]; unnw; clarify.
  destruct VR0 as [(loc2 & loc2' & ? & ?&?&?& VREL2)|VREL2]; [|by apply wlocal_nonref in VREL2]; unnw; clarify.
  apply WRE in VREL1; simpl in VREL1; repeat intro.
  destruct (eq_nat_dec loc1 loc2) as [|N];
   [assert (loc1' = loc2'); [by apply (proj1(proj2(proj2_sig sref')) _ _ _ VREL1 _ _ _ VREL2)|subst]
   |assert (loc1' <> loc2'); 
      [by intro; subst; destruct N; apply (proj1(proj2(proj2_sig sref')) _ _ _ VREL1 _ _ _ VREL2)|]].
  - by eapply wexp_Terminate with (v1 := Vtrue) (v2 := Vtrue); simpls; eauto using wextpub_trans; vauto.
  - by eapply wexp_Terminate with (v1 := Vfalse) (v2 := Vfalse); simpls; eauto using wextpub_trans; vauto.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Recursive types *)
(*----------------------------------------------------------------------------*)

Lemma compat_roll : 
  forall D G ty 
    e e' (E: wreq D G (vsubst 0 (Tmu ty) ty) e e'),
    wreq D G (Tmu ty) (Eroll e) (Eroll e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; eauto using lc_vsubstD.
  intros; simpls. 
  replace_all (forall a, Eroll a = app_cont (Kroll Khole) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  replace_all (forall a : val, Eroll a = Vroll a).
  eapply wexp_val; eauto; intros.
  do 2 econstructor; eauto.
  rewrite tsubst_typ_vsubst in VREL; eauto using lc_vsubstD.
Qed.

Lemma compat_unroll : 
  forall D G ty
    e e' (E: wreq D G (Tmu ty) e e'),
    wreq D G (vsubst 0 (Tmu ty) ty) (Eunroll e) (Eunroll e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; eauto using lc_vsubst.
  intros; simpls. 
  replace_all (forall a, Eunroll a = app_cont (Kunroll Khole) a).
  eapply wexp_app_cont, WEXP; eauto; []; intros; simpl.
  do 3 red; intros; destruct VREL; inv REL.
  econstructor 2; eauto; simpl; vauto.
  rewrite tsubst_typ_vsubst; eauto using lc_vsubstD.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Existential types *)
(*----------------------------------------------------------------------------*)

Lemma compat_pack : 
  forall D G ty ty' (ty'OK: lc_typ 0 ty')
    e e' (E: wreq D G (vsubst 0 ty' ty) e e'),
    wreq D G (Texists ty) (Epack e) (Epack e').
Proof.
  intros; eapply (meta1r E); clear E.
  intros; destruct E1; constructor; simpls; eauto using lc_vsubstD.
  intros; simpls. 
  replace_all (forall a, Epack a = app_cont (Kpack Khole) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  replace_all (forall a : val, Epack a = Vpack a).
  rewrite tsubst_typ_vsubst in VREL; [eapply wexp_val| |];
   eauto using lc_tsubst, lc_vsubstD.
Qed.

Lemma compat_unpack : 
  forall D G ty ty' aa 
    e1 e1' (E1: wreq D G (Texists ty) e1 e1')
    x e2 e2' (E2: wreq (aa :: D) ((x, vsubst 0 (Tname aa) ty) :: G) ty' e2 e2')
    (FRESH1: forall x ty, In (x,ty) G -> ~ In aa (ftn_typ ty))
    (FRESH2: ~ In aa (ftn_typ ty))
    (FRESH3: ~ In aa (ftn_typ ty')),
  wreq D G ty' (Eunpack x e1 e2) (Eunpack x e1' e2').
Proof.
  intros; eapply (meta2 E1 E2); clear E1 E2.
  intros; destruct E1, E2; constructor; simpls; des; eauto.
  - by rewrite !list_minus_app, <-!list_minus_app_r; simpl; rewrite FV1, FV0.
  - by rewrite !list_minus_app, <-!list_minus_app_r; simpl; rewrite FV3, FV2.

  intros; simpls.
  replace_all (forall x a b, Eunpack x a b = app_cont (Kunpack x Khole b) a).
  eapply wexp_app_cont; eauto; do 2 red; intros; fold wexp; simpl.
  eapply wexp_mon; eauto; destruct VREL; inv REL; red; intros.
  refine (mp (WEXP0 s' _ g'OK ((aa, ty'0) :: d) eq_refl _ ((x, _, (v0, v'0)) :: gg) eq_refl) _).
    by intross; des; clarify; simpl; auto.  
  clear WEXP0; intros WEXP0; red in gOK|-*; intros; des.
  rewrite <- (tsubst_typ_nin aa ty'0 _ _ FRESH3).
  eapply wexp_core_reduces, WEXP0; try eapply reduces_step; try eapply Rpack; eauto.
  - rewrite subst_exp_app_disj; simpl.
    + rewrite <- !(subst_exp_remdup _ (_ :: _)); simpl.
      rewrite <- list_minus2_remdup2, <- !list_minus2_app_r; simpl.
      erewrite list_minus2_eq; vauto; simpl; tauto.
    + apply subst_closed_minus2, (subst_closed_gg fst).
      by intros ((?&?)&?&?); intros; simpl; assert (X:= vclos_closed); hdes; eauto.
    + rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
      by repeat destruct eq_termvar; clarify.
  - rewrite subst_exp_app_disj; simpl.
    + rewrite <- !(subst_exp_remdup _ (_ :: _)); simpl.
      rewrite <- list_minus2_remdup2, <- !list_minus2_app_r; simpl.
      erewrite list_minus2_eq; vauto; simpl; tauto.
    + apply subst_closed_minus2, (subst_closed_gg snd).
      by intros ((?&?)&?&?); intros; simpl; assert (X:= vclos_closed); hdes; eauto.
    + rewrite list_map_fst_minus2; apply list_disj_comm, list_disj_minus_l; simpl.
      by repeat destruct eq_termvar; clarify.
 - simpl; intros; des; clarify.
   + rewrite tsubst_typ_vsubst; simpls.
       destruct eq_typename; simpls.
       by rewrite tsubst_typ_nin; eauto.
     by intros; des; subst; eauto.
   + assert (CLO := ggOK _ _ _ _ IN); red in EXT, g'OK.
     rewrite tsubst_typ_nin; eauto using vclos_mon.
     eapply FRESH1, in_map_fst; eauto.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Universal types *)
(*----------------------------------------------------------------------------*)

Program Definition wgen D G fty e e'
   (FV1 : list_minus eq_termvar (fv_exp e) (map fst G) = nil)
   (FV2 : list_minus eq_termvar (fv_exp e') (map fst G) = nil)
:= wsingle
   (fun r ty v v' =>
      exists gg d,
           map fst d = D 
        /\ map fst gg = G
        /\ (forall x : typename * typ, In x d -> lc_typ 0 (snd x))
        /\ (forall (x0 : termvar) (ty : typ) v1 v2,
              In (x0, ty, (v1, v2)) gg -> vclos (r) (tsubst_typ d ty) v1 v2)
        /\ lc_typ 0 ty
        /\ ty = FTforall (tsubst_typ d fty)
        /\ v  = subst_val (map_pair fst (fun x => exp_of_val (fst x)) gg) (Vgen e)
        /\ v' = subst_val (map_pair fst (fun x => exp_of_val (snd x)) gg) (Vgen e')) 
   (fun _ h h' => h = hemp /\ h' = hemp)
   _ _ _ _ _.
Next Obligation. des; eauto 15 using vclos_mon, vclos_closed. Qed.
Next Obligation. 
by des; subst; split; eauto; split; simpl; rewrite fv_subst_exp, ?map_fst_map_pair; eauto;
    apply subst_closed_gg; 
     intros ((?&?)&?&?); intros; simpl; assert (X:= vclos_closed); hdes; eauto.
Qed.
Next Obligation. des; subst; simpls; split; eexists; econstructor. Qed.

Lemma wgen_wdisj: forall {w D G fty e e' FV1 FV2}, 
  wdisj w (wgen D G fty e e' FV1 FV2).
Proof. by repeat intro; eauto. Qed.
Hint Resolve @wgen_wdisj.

Lemma wgen_stable: forall D G fty e e' FV1 FV2, 
  wstable (wgen D G fty e e' FV1 FV2).
Proof. by repeat intro; simpls; des; subst; discriminate. Qed.
Hint Resolve wgen_stable.

Lemma wconsistent_gen:
  forall D G fty e e' aa FV1 FV2 w 
    (C : wconsistent (wlift w))
    (E : wequiv (aa :: D) G (wlift w) (vsubst 0 (Tname aa) fty) e e')
    (FRESH1 : forall x ty, In (x,ty) G -> ~ In aa (ftn_typ ty))
    (FRESH2 : ~ In aa (ftn_typ fty)),
  wconsistent (wlift (wprod w (wgen D G fty e e' FV1 FV2))).
Proof.
  red; intros; destruct s as [s [s' []]].
  apply wstuck_lift, wstuck_prod in APP; des.
    exploit (C (fun s => g (fst s, (snd s, ())))).
    - by eapply wglob_prod1 in gOK; eauto.
    - by instantiate (4:= (s,s')); eapply wstuck_lift; eauto.
    - intros; des; exists e1'; exists e2'; repeat split; try done.
      by eapply wexp_extend1; simpls; eauto.

  inv APP; clear APP; simpl in FREL; des; clarify.
  subst f1 f2 ty0.
  do 2 eexists; do 2 (split; [by vauto|]); simpl.
  eapply wexp_extend1; simpls; eauto.
  rewrite <- FREL in E; rewrite <- FREL0 in FRESH1; destruct E.
  specialize (WEXP (s,s') _ (wglob_prod1 wgen_wdisj gOK ()) ((aa, ty') :: d) eq_refl).
  rewrite tsubst_typ_vsubst in WEXP; simpl in WEXP; eauto using lc_vsubstD.
  2:by intros; inv H; try subst x; eauto.
  destruct (eq_typename aa aa); clarify.
  rewrite tsubst_typ_nin in WEXP; [apply WEXP|]; auto.
    by intros; des; try subst x; eauto.
  intros; rewrite tsubst_typ_nin; eauto.
  eapply FRESH1, in_map_fst; eauto.
Qed.

Lemma compat_gen : 
  forall D G ty aa
    e e' (E: wreq (aa :: D) G (vsubst 0 (Tname aa) ty) e e')
    (FRESH1 : forall x ty, In (x,ty) G -> ~ In aa (ftn_typ ty))
    (FRESH2 : ~ In aa (ftn_typ ty)),
  wreq D G (Tforall ty) (Egen e) (Egen e').
Proof.
  red; intros; specialize (E _ INF); des; rdes WEQ; destruct EQ; simpls; unnw.
  eexists (wprod w (wgen D G ty e e' FV1 FV2)).
  split; [by destruct 1; apply NAM|split;[|split;[|split]]]; eauto.
  - eby apply winhabited_prod; try edone; exists (sref0,()); 
        repeat exists hemp; repeat split; vauto.
  - eby eapply wconsistent_gen.
  - constructor; simpl; eauto 15 using lc_vsubstD. 
    red; intros; simpl.
    replace_all (forall a, Egen a = Vgen a).
    eapply wexp_val; auto; intros; do 2 econstructor.
    apply (proj2 (proj2 gOK)); right; right.
    do 2 eexists; simpls; repeat (split; eauto using lc_tsubst, lc_vsubstD).
Qed.

Lemma compat_inst :
  forall D G ty ty' (LCty': lc_typ 0 ty')
    e e' (E1: wreq D G (Tforall ty) e e'),
  wreq D G (vsubst 0 ty' ty) (Einst e) (Einst e').
Proof.
  intros; eapply (meta1 E1); clear E1.
  intros; destruct E1; constructor; simpls; des; eauto using lc_vsubst.
  red; intros; simpl. 
  replace_all (forall x, Einst x = app_cont (Kinst Khole) x).
  eapply wexp_app_cont, WEXP; eauto; []; intros; simpl.
  do 2 red; intros; destruct VREL; inv REL.
  eapply wexp_mon; eauto; red; intros.
  econstructor 3 with (K1 := Khole) (K2 := Khole) (ty' := vsubst 0 (tsubst_typ d ty') _); 
    simpl; eauto using reduces_nil, wstuck_Inst, lc_tsubst.
  red; intros; rewrite tsubst_typ_vsubst; eauto; eapply wexp_val; eauto.
Qed.

(*----------------------------------------------------------------------------*)
(** * Soundness *)
(*----------------------------------------------------------------------------*)

(*----------------------------------------------------------------------------*)
(** ** Fundamental property (partial reflexivity) *)
(*----------------------------------------------------------------------------*)

Ltac list_minus_emp_tac := 
  intros; repeat match goal with
           | H : _ |- _ => generalize (proj1 (list_minus_emp_spec _ _ _) H); clear H; intro H
           | H : _ |- _ => exploit H; try eassumption; []; clear H; intro H; 
                    generalize (proj1 (list_minus_emp_spec _ _ _) H); clear H; intro H
         end; eauto.

Theorem wreq_refl : 
  forall D G e ty (WT: hastype D G e ty), wreq D G ty e e.
Proof.
  induction 1; intros; try by 
    repeat match goal with [H : @hastype _ _ _ _ |- _] => 
             eapply hastype_wftyp in H; inv H end;
    try inv H;
    simpls; des; eauto 
      using compat_var, compat_if, compat_pair, compat_fst, compat_snd, 
            compat_inl, compat_inr, compat_case, compat_fix, compat_app, 
            compat_ref, compat_read, compat_write, compat_refeq, 
            compat_unroll, compat_roll, compat_inst, compat_pack, 
            lc_vsubstD, list_assoc_in. 
  
  - inv H; eapply meta0r; simpls; constructor; eauto; intros; simpls.
    by replace_all (Eunit = Vunit); eapply wexp_val; vauto.
  - inv H; eapply meta0r; simpls; constructor; eauto; intros; simpls.
    by replace_all (forall a, Eint a = Vint a); eapply wexp_val; vauto.
  - inv H; eapply meta0r; simpls; constructor; eauto; intros; simpls.
    by replace_all (Etrue = Vtrue); eapply wexp_val; vauto.
  - inv H; eapply meta0r; simpls; constructor; eauto; intros; simpls.
    by replace_all (Efalse = Vfalse); eapply wexp_val; vauto.
  - inv H; destruct H1; list_minus_emp_tac.
    by eapply compat_gen; eauto; list_minus_emp_tac.
  - assert (H1 := hastype_wftyp WT1); inv H; inv H1; inv H2; list_minus_emp_tac.
    eapply compat_unpack; eauto; list_minus_emp_tac.
Qed.

Corollary wreq_reflp : 
  forall D G p ty (WT: phastype D G p ty), wreq D G ty p p.
Proof. auto using wreq_refl, hastype_erase. Qed.

(*----------------------------------------------------------------------------*)
(** ** Symmetry *)
(*----------------------------------------------------------------------------*)

Definition fsym (r : vrelf) : vrelf := fun ty v1 v2 => r ty v2 v1.

Definition hsym (r : hrel) : hrel := fun h1 h2 => r h2 h1.

Program Definition rsym (s: wst wref) : wst wref :=
  @exist _ _ (fun ty l l' => s ty l' l) _.
Next Obligation.
destruct s; simpls; rrdes w; hdes; repeat split; subst; eauto 15.
Defined.

Hint Unfold fsym hsym rsym.

Lemma rsym_mon: forall ps ps' (PE: wext wref ps' ps), 
  wext wref (rsym ps') (rsym ps).
Proof. repeat intro; simpls; eauto. Qed.

Program Definition wsym (w : world_local) : world_local :=
  {| wldlocal := 
  {| wnam := wnam w
   ; wst := wst w
   ; wext := wext w
   ; wextpub := wextpub w
   ; wval sr s r := fsym (wval w (rsym sr) s (fsym r))
   ; wheap sr s r := hsym (wheap w (rsym sr) s (fsym r)) |} |}.
Next Obligation. eauto 10 using wext_trans, wextpub_trans. Qed. 
Next Obligation. eauto 10 using wext_trans, wextpub_trans. Qed.
Next Obligation. eauto 10 using wval_mon, rsym_mon. Qed.
Next Obligation. eapply wval_closed in V; des; rhdes C; eauto 10. Qed.
Next Obligation. eauto using wheap_mon. Qed.
Next Obligation. eauto using wnam_supports. Qed.
Next Obligation. eapply wval_arrow_wf in L; des; eauto. Qed.
Next Obligation. eapply wval_forall_wf in L; des; eauto. Qed.
Next Obligation. eauto using wlocal_nonref. Qed.

Definition gsym w (g : wst (wlift (wsym w)) -> vrelf) : wst (wlift w) -> vrelf :=
  fun s => let (sr, sl) := s in fsym (g (rsym sr, sl)).

Hint Unfold gsym.
  
Lemma vclos_sym: forall r ty v v' (VC: vclos (fsym r) ty v' v), vclos r ty v v'.
Proof. intros; eapply (vclos_induction VC); intros; destruct IH; eauto. Qed.

Lemma rsym_inv: forall s, rsym (rsym s) = s.
Proof.
intros; destruct s; unfold rsym; simpls; erewrite (proof_irrelevance _ _ w).
revert w; rewrite (eta3 x); eauto.
Qed.

Lemma gsym_inv : forall w g sr s, fsym (g (sr, s)) = @gsym w g (rsym sr, s).
Proof. by simpl; intros; rewrite rsym_inv. Qed.

Lemma wglob_sym: forall w g (gOK: wglob (wlift (wsym w)) g),
  wglob (wlift w) (gsym g).
Proof.
  intros; rdes gOK; rrhdes GCLO; rrhdes GSUP.
  split; [|split]; repeat intro; try destruct s; try destruct s'; eauto 10.
    by eapply GMON; eauto; simpls; des; eauto.
  by split; [|split]; repeat intro; 
      [eapply LE|specialize (GEREF _ _ _ _ R)|specialize (GENAM _ _ _ _ NM R)];
       simpls; des; subst; try rewrite rsym_inv in *; eauto 15.
Qed.

Lemma wval_sym: forall w sr s r ty v1 v2
    (WV: wval (wlift (wsym w)) () (rsym sr,s) (fsym r) ty v2 v1),
  wval (wlift w) () (sr,s) r ty v1 v2.
Proof. intros; simpls; des; subst; eauto 15 using wval_mon. Qed.

Lemma wref_heap_sym: forall sr r h1 h2
    (WH: wheap wref () (rsym sr) (fsym r) h2 h1),
  wheap wref () sr r h1 h2.
Proof.
  intros; simpls; des; split; eauto 10.
  by repeat intro; specialize (HSAT _ _ _ R); des; eauto 15 using vclos_sym.
Qed.

Lemma wheap_sym: forall w sr s r h1 h2
    (WH: wheap (wlift (wsym w)) () (rsym sr,s) (fsym r) h2 h1),
  wheap (wlift w) () (sr,s) r h1 h2.
Proof.
  intros; rrdes WH; simpl in WH'; rewrite rsym_inv in WH'; repeat red.
  eauto 15 using wval_mon, wheap_mon, wref_heap_sym.
Qed.

Lemma wstuck_sym: forall rf rv ty e1 e2 (STK: wstuck (fsym rf) (fsym rv) ty e2 e1),
  wstuck rf rv ty e1 e2.
Proof. intros; destruct STK; subst; eauto 10 using vclos_sym. Qed.

Lemma wexp_sym: forall w g (gOK: wglob (wlift (wsym w)) g) sr0 s0 sr s ty e e' 
    (WE: wexp (wlift w) (gsym g) (rsym sr0,s0) (rsym sr,s) ty e' e),
  wexp (wlift (wsym w)) g (sr0,s0) (sr,s) ty e e'.
Proof.
  cofix CIH; repeat intro.
  refine (mp (WE _ _ _ _ _ HPLUS' _ _ HPLUS) _).
    by eapply wheap_sym; simpl gsym; rewrite rsym_inv; eauto using wheap_mon.
  intros X; depdes X.
  - by econstructor 1; eauto.
  - destruct s' as (sr' & s'); rrdes EXT; rrdes EXTP; rrdes HREL0; rrdes WH. 
    eapply wexp_Terminate with (s':=(rsym sr',s')); simpls; eauto using vclos_sym.
    rewrite rsym_inv; do 4 eexists; do 2 (split; eauto 10).
    by repeat intro; specialize (HSAT _ _ _ R); des; eauto 10 using vclos_sym.
  - destruct s' as (sr' & s'); rrdes EXT; rrdes EXTP; rrdes HREL0; rrdes WH. 
    eapply wexp_Call with (s':=(rsym sr',s')); simpls; eauto using vclos_sym, wstuck_sym.
    + rewrite rsym_inv; do 4 eexists; do 2 (split; eauto 10).
      by repeat intro; specialize (HSAT _ _ _ R); des; eauto 10 using vclos_sym.
    + destruct s'' as (sr'' & s''); repeat intro; eapply CIH; eauto.
      by des; eapply KREL; intros; simpls; try destruct a; try rewrite rsym_inv; 
          eauto using wglob_sym, vclos_sym, vclos_mon.
Qed.

Lemma winhabited_sym: forall w (INH: winhabited (wlift w)), winhabited (wlift (wsym w)).
Proof. 
  red; intros; specialize (INH _ (wglob_sym gOK)); simpls; des; destruct s0 as (sr, s).
  exists (rsym sr, s); simpl; rewrite rsym_inv.
  do 4 eexists; do 2 (split; eauto 10).
  by repeat intro; specialize (HSAT _ _ _ R); des; eauto 10 using vclos_sym.
Qed.

Lemma wconsistent_sym: forall w (CS: wconsistent (wlift w)), wconsistent (wlift (wsym w)).
Proof.
  red; intros; destruct s as (sr, s); exploit (CS _ (wglob_sym gOK)).
    eapply wstuck_sym, wstuck_mon; eauto. 
      intros; eapply wval_sym with (sr := rsym sr) (s := s).
      by simpl gsym; rewrite rsym_inv; eauto using wval_mon.
    by simpl gsym; rewrite rsym_inv; eauto.    
  intros; des; eauto 20 using (@wexp_sym w).
Qed.

Lemma wstable_sym: forall w (WEQ : wstable w), wstable (wsym w).
Proof.
  repeat intro; assert (X:=gOK); rdes X.
  refine (mp (WEQ _ (wglob_sym gOK) (rsym sp) s h2 h1 _ (rsym sp') _ _ _ _ _ _ _ _) _);
   simpl gsym; try rewrite rsym_inv; try by simpl; eauto using wglob_sym, wheap_mon.
  by eapply wref_heap_sym; rewrite rsym_inv; eauto using wheap_mon.
Qed.

Theorem wreq_sym :
  forall D G ty e1 e2 (WEQ: wreq D G ty e1 e2), wreq D G ty e2 e1.
Proof.
  red; intros; specialize (WEQ N INF); des.
  eexists (wsym w); split; [by eauto|].
  split; [by eauto using wstable_sym|].
  rdes WEQ; destruct EQ.
  split; [by apply winhabited_sym|].
  split; [by apply wconsistent_sym|].
  econstructor; eauto; intros; destruct s as (sr & s); eapply (@wexp_sym w); eauto.
  specialize (WEXP (rsym sr, s) _ (wglob_sym gOK) _ DEQ dOK (map_pair id swap gg)).
  rewrite map_pair_fst_swap, map_pair_snd_swap in WEXP.
  eapply WEXP; [by rewrite map_fst_map_pair, map_id|].
  intros; simpl; rewrite rsym_inv; eapply in_map_pair_swap in IN.
  by eauto 10 using vclos_sym, vclos_mon.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Congruence *)
(*----------------------------------------------------------------------------*)

Theorem wreq_cong : 
   forall C D G ty D' G' ty' (WTC: wfctx C D G ty D' G' ty')
     (p1 p2 : prg) (WEQ: wreq D G ty p1 p2),
   wreq D' G' ty' (app_ctx C p1) (app_ctx C p2).
Proof.
  induction 1; intros; simpls; try by 
    repeat match goal with [H : @wftyp _ _ _ |- _] => inv H; clear H end;
    repeat match goal with [H : @wfctx _ _ _ _ _ _ _ |- _] => 
             eapply wfctx_wftyp in H; inv H end;
    simpls; des; eauto
      using compat_var, compat_if, compat_pair, compat_fst, compat_snd, 
            compat_inl, compat_inr, compat_case, compat_fix, compat_app, 
            compat_ref, compat_read, compat_write, compat_refeq, wreq_reflp.

  - by inv H; eauto using compat_roll.
  - by assert (H' := wfctx_wftyp WTC); inv H'; eauto using compat_unroll.
  - inv H; destruct H1; list_minus_emp_tac.
    by eapply compat_gen; eauto; list_minus_emp_tac.
  - by assert (H' := wfctx_wftyp WTC); inv H; inv H'; eapply compat_inst; eauto. 
  - by assert (H' := wfctx_wftyp WTC); inv H; inv H';
       eauto using compat_pack, lc_vsubstD. 
  - assert (H' := wfctx_wftyp WTC); inv H'; inv H2.
    inv H0; list_minus_emp_tac.
    by eapply compat_unpack; eauto using wreq_reflp; list_minus_emp_tac.
  - assert (H' := wfctx_wftyp WTC); inv H'; inv H2.
    assert (H'' := hastype_wftyp (hastype_erase H)); inv H''; inv H7. 
    inv H0; list_minus_emp_tac.
    by eapply compat_unpack; eauto using wreq_reflp; list_minus_emp_tac.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Adequacy *)
(*----------------------------------------------------------------------------*)

Theorem wreq_adequate : 
  forall ty e1 e2 (WEQ: wreq nil nil ty e1 e2) h1 h2,
       ~ gets_stuck h1 e1
    /\ ~ gets_stuck h2 e2
    /\ (diverges h1 e1 <-> diverges h2 e2).
Proof.
  intros; refine (mp (WEQ (fun x => True) _) _).
    by eexists (fun x => `x), (fun x => exist _ x I); split; eauto using proj1_sig_inj.
  intros; des; rdes WEQ0.
  destruct (INH (minvr (wlift w)) (minvr_glob _)) as (s0 & IN); clear INH.
  destruct EQ.
  specialize (WEXP s0 _ (minvr_glob (wlift w)) nil eq_refl (fun _ => False_rect _)
                   nil eq_refl (fun _ _ _ _ => False_rect _)).
  eapply wexp_no_external in WEXP; eauto using minvr_glob; rewrite !subst_exp_nil in *.
  - refine (mp (WEXP _ _ _ h1 _ _ h2 _ _) _); eauto.
    by intros X; destruct X; [| |inv EREL];
        repeat split; eauto using diverges_no_stuck, reduces_val_no_stuck;
         eby intro K; eapply reduces_val_no_diverges in K.
  - by intros; split; intros; [destruct H|]; eauto using wval_mon.
Qed.

(*----------------------------------------------------------------------------*)
(** ** Inclusion in contextual equivalence *)
(*----------------------------------------------------------------------------*)

Theorem wreq_soundness : 
  forall D G ty p1 p2,
    wreq D G ty (erase_prg p1) (erase_prg p2) ->
  ctx_equiv D G ty p1 p2.
Proof. by red; intros; eapply wreq_adequate, wreq_cong; eauto. Qed.
